import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { TreeView } from '@syncfusion/ej2-navigations';
import { DropDownListComponent } from '@syncfusion/ej2-angular-dropdowns';
import {  FormGroup,FormBuilder,Validators } from '@angular/forms';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    styleUrls: ['app.component.css'],
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    // DropDownList instance
    @ViewChild('sample1') 
    public dropdownObj: any;
    skillForm: FormGroup;
ngOnInit() {
    
  }
  constructor(private fb: FormBuilder) {
        this.createForm();
    }
    createForm() : void {
        this.skillForm = this.fb.group({
            parentId: ['', Validators.required],
        });
     }
  public treeObj: TreeView;

 public localData: { [key: string]: Object }[] = null;

 public labelData: { [key: string]: Object }[] = null;
   

    public onOpen = () => { 

this.labelData = [];

          // modifying the dropdownlist's classes for styling
  this.dropdownObj.popupObj.element.firstElementChild.className = "e-content overflow";
  // rendering the treeview only on first time 
    if (this.treeObj == null || this.treeObj == undefined) {
      this.treeObj = new TreeView({
         fields: { dataSource: this.labelData, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' },
        // use the nodeselected event to add the text to dropdown's input element.
        nodeSelected:  (args: any) => {
          let drop = (document.getElementById("games") as any ).ej2_instances[0];
          drop.inputElement.value = args.nodeData.text;
        }
      });
    this.treeObj.appendTo('#tree');
    }
    }
}
